section .data
maxlen  equ     100
rword   db      "Please, enter a word? ", 00h
buffer  times   maxlen + 1 db 00h
pal     db      "This word is a palindrome", 00h
nopal   db      "This word isn't a palindrome", 00h

section .text
extern io_get_string, io_print_string, io_newline
global main
main:
        mov     ebp, esp
        ; Execute the loop until there is an empty input (user just hit ENTER)
loop:
        ; Ask for word
        mov     eax, rword
        call    io_print_string
        ; Get name from keyboard input
        mov     eax, buffer
        mov     edx, maxlen + 1
        call    io_get_string
        ; If no input (user just hit ENTER), then exit
        lea     esi, [buffer]
        mov     bl, [esi]
        cmp     bl, 0Ah                ; 0AH (linefeed) indicates end of input
        je      exit
        xor     ecx, ecx               ; CL register will be used as character counter
ccount:
        ; Count actual number of characters
        inc     cl
        inc     esi
        mov     bl, [esi]
        cmp     bl, 0Ah                ; check if end of input
        jne     ccount                 ; if not, continue with next character
        ; Compare the word read from left to right with the word read from right to left
        ; Initialization: ESI pointing to first character, EDI to last character of the word
        lea     esi, [buffer]
        lea     edi, [buffer + ecx - 1]
check:
        ; Compare the word with its reverse character by character
        ; Do this until all characters have been done,
        ; or until the two characters aren't equal anymore
        mov     byte bl, [esi]         ; actual character of the word
        mov     byte dl, [edi]         ; actual character of the reversed word
        inc     esi                    ; ESI pointing to next character (reading of word is left to right)
        dec     edi                    ; EDI pointing to previous character (redaing of reversed word is right to left)
        dec     cl                     ; decrement the character counter
        cmp     cl, 0                  ; if the character couner is zero, comparison is done
        je      done
        cmp     bl, dl                 ; compare character of word with charater of reversed word
        je      check                  ; if they are still equal, continue with next character
done:
        ; If the character counter is zero at this point, all characters of the word
        ; are equal to those of the reversed word and the word is a palindrome;
        ; otherwise the word isn't a palindrome
        cmp     cl, 0
        je      ispal
        ; The word isn't a palindrome
        mov     eax, nopal
        jmp     display
ispal:
        ; The word is a palindrome
        mov     eax, pal
display:
        ; Display if word is or is not a palindrome,
        ; then redo the loop (asking user for another word)
        call    io_print_string
        call    io_newline
        jmp     loop
exit:
        ; Program termination
        xor     eax, eax
        ret
